<?php
/*
Plugin Name: dw2wp
Plugin URI: http://www.feldhausnetz.de/
Description: With this plugin you can include your DokuWiki installation in a Wordpress static page. Configure the location of your DokuWiki installation under options. To include your DokuWiki installation create a static page and insert <dokuwiki>:ns:page</dokuwiki> with ns beeing a namespace and page the pagename to show at the beginning.
Version: 0.3
Author: floffel
Author URI: http://www.feldhausnetz.de/
*/

/*  Copyright 2008  Florian Feldhaus  (email : florian.feldhaus@udo.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


if (!class_exists("dw2wp")) {
	class dw2wp {
		function dw2wp() { //constructor
		}
	
		function addHeaderCode() {
			// echo '<link type="text/css" rel="stylesheet" href="' . get_option('dw2wp_url') . '/lib/exe/css.php?s=screen" />' . "\n";
			$style = '<style type="text/css">'."\n";
			$style = $style . get_option('dw2wp_css') . "\n";
			$style = $style . '</style>'."\n";
			echo $style;
		}
		
		### Function: Print Option Menu
		function dw2wp_menu() {
			if (function_exists('add_options_page')) {
				add_options_page('DW2WP','DW2WP', 8, 'testoptions', array(&$this, 'dw2wp_options')) ;
			}
		}
		
		function dw2wp_options() {
		
			if ( !empty($_POST ) ) : ?>
				<div id="message" class="updated fade"><p><strong><?php _e('Options saved.') ?></strong></p></div>
			<?php endif; ?>
			
			<div class="wrap">
				<h2><?php _e('DW2WP Configuration'); ?></h2>
				<div class="narrow" style="margin:0;">
					<form method="post" action="options.php" style="margin: 0; width: 600px; ">
						<?php wp_nonce_field('update-options') ?>
						<h3><label><?php _e('Base URL of your DokuWiki installation'); ?></label></h3>
						<input type="text" name="dw2wp_url" size="30" value="<?php echo get_option('dw2wp_url'); ?>">
						<input type="hidden" name="action" value="update" />
						<input type="hidden" name="page_options" value="dw2wp_url" />
						<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
					</form>
					<form method="post" action="options.php" style="margin: 0; width: 600px; ">
						<?php wp_nonce_field('update-options') ?>
						<h3><label><?php _e('CSS of your DokuWiki installation'); ?></label></h3>
						<textarea type="text" name="dw2wp_css" cols="120" rows="12"><?php echo get_option('dw2wp_css'); ?></textarea>
						<input type="hidden" name="action" value="update" />
						<input type="hidden" name="page_options" value="dw2wp_css" />
						<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
					</form>
					<form method="post" action="options.php" style="margin: 0; width: 600px; ">
						<?php wp_nonce_field('update-options') ?>
						<h3><label><?php _e('HTML before the DokuWiki Page'); ?></label></h3>
						<textarea type="text" name="dw2wp_html_before" cols="120" rows="4"><?php echo get_option('dw2wp_html_before'); ?></textarea>
						<input type="hidden" name="action" value="update" />
						<input type="hidden" name="page_options" value="dw2wp_html_before" />
						<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
					</form>
					<form method="post" action="options.php" style="margin: 0; width: 600px; ">
						<?php wp_nonce_field('update-options') ?>
						<h3><label><?php _e('HTML after the DokuWiki Page'); ?></label></h3>
						<textarea type="text" name="dw2wp_html_after" cols="120" rows="4"><?php echo get_option('dw2wp_html_after'); ?></textarea>
						<input type="hidden" name="action" value="update" />
						<input type="hidden" name="page_options" value="dw2wp_html_after" />
						<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
					</form>
				</div>
			</div>
			<?php
		}
		
		function import_dw($matches){
			global $wp_query;
			$export_cmd = '?do=export_xhtmlbody';
			try {				
				$std_filename = $filename = get_option('dw2wp_url') . $matches[1] . $export_cmd;
				$dw_query_var = attribute_escape($wp_query->query_vars['dw']);
				if ($dw_query_var != '') {
					$filename = get_option('dw2wp_url') . $dw_query_var . $export_cmd;
				} else {
					$filename = get_option('dw2wp_url') . $matches[1] . $export_cmd;
				}
				$output = @file_get_contents($filename);
				if (trim($output == '')) {
					$output = @file_get_contents(std_filename);
				}
				if (trim($output == '')) {
					$output = "Page not found!";
				}
				
				$replace_pattern = '&<a href="([^"]*)"([^c]*)class="media"([^>]*)><img src="([^"]*)"([^/]*)/></a>&is';
				if (get_permalink() != '') {
					$replacement = '<a href="'.get_permalink().'?dw=\1"\2class="media"\3><img src="' . get_option('dw2wp_url') . '\4"\5/></a>'; 
				} else {
					$replacement = '<a href="?page_id='.$wp_query->query_vars['page_id'].'&dw=\1"\2class="media"\3><img src="' . get_option('dw2wp_url') . '\4"\5/></a>'; 
				}
				$output = preg_replace($replace_pattern,$replacement, $output);
				
				$replace_pattern = '&<a href="([^"]*)"([^c]*)class="wikilink1"([^>]*)>(.*?)</a>&is';
				if (get_permalink() != '') {
					$replacement = '<a href="'.get_permalink().'?dw=\1"\2class="wikilink1"\3>\4</a>'; 
				} else {
					$replacement = '<a href="?page_id='.$wp_query->query_vars['page_id'].'&dw=\1"\2class="wikilink1"\3>\4</a>'; 
				}
				$output = get_option('dw2wp_html_before') . "\n" . preg_replace($replace_pattern,$replacement, $output) . "\n" . get_option('dw2wp_html_after');
			} catch (Exception $e) {
			}
			return $output;
		}
		
		function insert_dw($content){
			$content = preg_replace_callback('/<dokuwiki>((.|\n)*?)<\/dokuwiki>/', array(&$this, 'import_dw'), $content);
			$content = preg_replace_callback('/\[dokuwiki\]((.|\n)*?)\[\/dokuwiki\]/', array(&$this, 'import_dw'), $content);
			$content = preg_replace('/<dokuwiki off>((.|\n)*?)<\/dokuwiki>/', '<dokuwiki>$1</dokuwiki>', $content);
			$content = preg_replace('/\[dokuwiki off\]((.|\n)*?)\[\/dokuwiki\]/', '<dokuwiki>$1</dokuwiki>', $content);
			return $content;
		}
		
		function dw2wp_queryvars( $qvars ){
			$qvars[] = 'dw';
			return $qvars;
		}

	
	}
	
} //End Class dw2wp

if (class_exists("dw2wp")) {
	$dw2wp = new dw2wp();
}

//Actions and Filters   
if (isset($dw2wp)) {
	//Actions
	add_action('wp_head', array(&$dw2wp, 'addHeaderCode'), 1);
	add_action('admin_menu', array(&$dw2wp, 'dw2wp_menu'), 1);
	//Filters
	add_filter('the_content', array(&$dw2wp, 'insert_dw'), 0);
	add_filter('query_vars', array(&$dw2wp, 'dw2wp_queryvars'), 0);
}

?>
